<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier3 extends AbstractStructArrayBase
{
    /**
     * The InternalTransportSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalTransportSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier3
     * @uses ArrayOfJP_InternalSupplier3::setInternalTransportSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalTransportSupplier
     */
    public function __construct(array $internalTransportSupplier = array())
    {
        $this
            ->setInternalTransportSupplier($internalTransportSupplier);
    }
    /**
     * Get InternalTransportSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalTransportSupplier()
    {
        return $this->InternalTransportSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setInternalTransportSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInternalTransportSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInternalTransportSupplierForArrayConstraintsFromSetInternalTransportSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InternalSupplier3InternalTransportSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplier3InternalTransportSupplierItem instanceof \StructType\JP_InternalSupplier) {
                $invalidValues[] = is_object($arrayOfJP_InternalSupplier3InternalTransportSupplierItem) ? get_class($arrayOfJP_InternalSupplier3InternalTransportSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_InternalSupplier3InternalTransportSupplierItem), var_export($arrayOfJP_InternalSupplier3InternalTransportSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InternalTransportSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InternalTransportSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalTransportSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier3
     */
    public function setInternalTransportSupplier(array $internalTransportSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($internalTransportSupplierArrayErrorMessage = self::validateInternalTransportSupplierForArrayConstraintsFromSetInternalTransportSupplier($internalTransportSupplier))) {
            throw new \InvalidArgumentException($internalTransportSupplierArrayErrorMessage, __LINE__);
        }
        $this->InternalTransportSupplier = $internalTransportSupplier;
        return $this;
    }
    /**
     * Add item to InternalTransportSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier3
     */
    public function addToInternalTransportSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalTransportSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InternalTransportSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalTransportSupplier
     */
    public function getAttributeName()
    {
        return 'InternalTransportSupplier';
    }
}
